export declare const sizeKeys: string[];
export declare const sizeMarginKeys: string[];
export declare const heightWidthKeys: string[];
export declare const heightWidthRadiusKeys: string[];
interface DefaultProps {
    [key: string]: boolean | string | {} | number;
}
declare type HeightWidthFunction = (height: number, width: number) => DefaultProps;
declare type HeightWidthRadiusFunction = (height: number, width: number, radius: number) => DefaultProps;
declare type SizeFunction = (size: number) => DefaultProps;
export declare const sizeDefaults: SizeFunction;
export declare const sizeMarginDefaults: SizeFunction;
export declare const heightWidthDefaults: HeightWidthFunction;
export declare const heightWidthRadiusDefaults: HeightWidthRadiusFunction;
export {};
